declare module '@webinex/react-validation' {
  interface ValidationProps {
    isValid: boolean;
    isChanged: boolean;
    errors: string[];
  }

  interface ValidatedControlOptions {
    valueProp?: string;
    onChangeEventName?: string;
  }

  type ValidationFn = (value: any) => string | undefined;

  interface ValidatedControlProps {
    validations?: ValidationFn[];
    onInvalid?: () => void;
    onValid?: () => void; 
  }

  type ValidationProviderContent = JSX.Element | ((c: ControlContainer) => JSX.Element);

  class ValidationProvider {
    ref?: (c: ControlContainer) => void;
    onInvalid?: () => void;
    onValid?: () => void;
    children?: ValidationProviderContent;
  }

  class ControlContainer {
    validate(): boolean;
    isValid: boolean;
  }

  function injectValidation<T>(constructor: T): T;

  function makeControl<T extends React.Component>(
    control: React.Component<ValidationProps>, options?: ValidatedControlOptions): T;
}